#include <bits/stdc++.h>
using namespace std;

const int VERBOSE = 0;

const int MOD = 1000000000;

int T, N, D;
vector<int> plot;

int main() {
    cin >> T >> N >> D;
    plot.resize(N);
    for (int n=0; n<N; ++n) cin >> plot[n];

    if (N == 1) {
        cout << 1 << endl;
        for (int d=0; d<D; ++d) cout << "0 " << (plot[0]+d+1)%MOD << endl;
        return 0;
    }

    map<int, int> pocet;
    for (int f : plot) ++pocet[f];

    int bestzac=0, bestkon=0, bestf=-1;
    for (auto rec : pocet) {
        int farba = rec.first;
        int zac = 0, kon = 0, dnu = 0;
        while (true) {
            if (kon - zac - dnu <= D) {
                // dobry usek
                if (kon - zac >= bestkon - bestzac) {
                    if (VERBOSE) {
                        if (farba != bestf || kon-zac > bestkon-bestzac) cout << "new or tied best " << (kon-zac) << " for color " << farba << " occurs " << pocet[farba] << endl;
                    }
                    bestzac = zac;
                    bestkon = kon;
                    bestf = farba;
                }
                if (kon == N) break;
                if (plot[kon] == farba) ++dnu;
                ++kon;
            } else {
                // zly usek
                if (plot[zac] == farba) --dnu;
                ++zac;
            }
        }
    }
    if (bestzac == 0 && bestkon == N && D == 1) {
        cout << (N-1) << endl << "0 " << ((bestf+1)%MOD) << endl;
        return 0;
    }
    
    cout << (bestkon - bestzac) << endl;
    if (D == 0) return 0;
    
    int treba = 0;
    int jedna_zla = -1;
    for (int i=bestzac; i<bestkon; ++i) if (plot[i] != bestf) { ++treba; jedna_zla = i; }

    if (treba == 0) {
        jedna_zla = bestzac;
        int nova_farba = (plot[jedna_zla]+1) % MOD;
        plot[jedna_zla] = nova_farba;
        cout << jedna_zla << " " << nova_farba << endl;
        treba = 1;
        --D;
    }

    while (D > treba) {
        int nova_farba = (plot[jedna_zla]+1) % MOD;
        if (nova_farba == bestf) nova_farba = (nova_farba+1) % MOD;
        plot[jedna_zla] = nova_farba;
        cout << jedna_zla << " " << nova_farba << endl;
        --D;
    }
    
    for (int i=bestzac; i<bestkon; ++i) if (plot[i] != bestf) cout << i << " " << bestf << endl;
}
