import java.util.*;
import java.math.*;

class plot {
    
    public int produce(int[] A, int E) {
        int N = A.length;
        int[] fullHistogram = new int[250000];
        for (int a : A) ++fullHistogram[a];
        int maxCnt = 0;
        for (int cnt : fullHistogram) maxCnt = Math.max( maxCnt, cnt );
        int minEdits = N - maxCnt;

        if (E == minEdits) return N;
        if (E == minEdits + 1) {
            if (N == 1) return 1;
            if (minEdits == 0) return N-1;
            return N;
        }
        if (E >= minEdits + 2) return N;

        int[] histogram = new int[250000]; // for each value its current count in the window
        int[] aggregate = new int[N+1]; // for each value in histogram[] its number of occurrences
        aggregate[0] = 250000;
        int best=0, lo=0, hi=0, maxfreq=0;

        while (true) {
            if (hi-lo-maxfreq <= E) {
                best = Math.max(best,hi-lo);
                // extend
                if (hi==N) break;
                --aggregate[ histogram[ A[hi] ] ];
                ++histogram[ A[hi] ];
                ++aggregate[ histogram[ A[hi] ] ];
                if (histogram[ A[hi] ] > maxfreq) maxfreq = histogram[ A[hi] ];
                ++hi;
            } else {
                // shrink
                --aggregate[ histogram[ A[lo] ] ];
                --histogram[ A[lo] ];
                ++aggregate[ histogram[ A[lo] ] ];
                while (aggregate[maxfreq]==0) --maxfreq;
                ++lo;
            }
        }
        return best;
    }

    public static void main(String[] args) {
        Scanner in = new Scanner( System.in );
        int T = in.nextInt();
        int N = in.nextInt();
        int D = in.nextInt();
        int[] A = new int[N];
        for (int n=0; n<N; ++n) A[n] = in.nextInt();
        plot MAIN = new plot();
        System.out.println( MAIN.produce( A, D ) );
    }
}
